# CRM API — Activities

> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities

This document contains every operation on the `Activities` resource.

---

# List activities

> **CRM API** · `GET /crm/activities`
> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities/operation/activitiesAll

List activities

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `raw` | query | `boolean` | No | Include raw response. Mostly used for debugging purposes |
| `x-apideck-consumer-id` | header | `string` | Yes | ID of the consumer which you want to get or push data from |
| `x-apideck-app-id` | header | `string` | Yes | The ID of your Unify application |
| `x-apideck-service-id` | header | `string` | No | Provide the service id you want to call (e.g., pipedrive). Only needed when a consumer has activated multiple integrations for a Unified API. |
| `cursor` | query | `string` | No | Cursor to start from. You can find cursors for next/previous pages in the meta.cursors property of the response. |
| `limit` | query | `integer` | No | Number of results to return. Minimum 1, Maximum 200, Default 20 |
| `filter` | query | `object` | No | Apply filters |
| `sort` | query | `object` | No | Apply sorting |
| `pass_through` | query | `object` | No | Optional unmapped key/values that will be passed through to downstream as query parameters. Ie: ?pass_through[search]=leads becomes ?search=leads |
| `fields` | query | `string` | No | The 'fields' parameter allows API users to specify the fields they want to include in the API response. If this parameter is not present, the API will return all available fields. If this parameter is present, only the fields specified in the comma-separated string will be included in the response. Nested properties can also be requested by using a dot notation. <br /><br />Example: `fields=name,email,addresses.city`<br /><br />In the example above, the response will only include the fields "name", "email" and "addresses.city". If any other fields are available, they will be excluded. |

### Responses

#### 200 — Activities

- `status_code` `integer` **required** — HTTP Response Status Code — example: `200`
- `status` `string` **required** — HTTP Response Status — example: `OK`
- `service` `string` **required** — Apideck ID of service provider — example: `zoho-crm`
- `resource` `string` **required** — Unified API resource name — example: `activities`
- `operation` `string` **required** — Operation performed — example: `all`
- `data` `array of object` **required**
  - `id` `string` — The unique identifier of the activity — example: `12345`
  - `downstream_id` `string` — The third-party API ID of original entity — example: `12345`
  - `activity_datetime` `string` — The date and time of the activity — example: `2021-05-01T12:00:00.000Z`
  - `duration_seconds` `integer` — The duration of the activity in seconds — example: `1800`
  - `user_id` `string` — The user related to the activity — example: `12345`
  - `account_id` `string` — The account related to the activity — example: `12345`
  - `contact_id` `string` — The contact related to the activity — example: `12345`
  - `company_id` `string` — The company related to the activity — example: `12345`
  - `opportunity_id` `string` — The opportunity related to the activity — example: `12345`
  - `lead_id` `string` — The lead related to the activity — example: `12345`
  - `owner_id` `string` — The owner of the activity — example: `12345`
  - `campaign_id` `string` — The campaign related to the activity — example: `12345`
  - `case_id` `string` — The case related to the activity — example: `12345`
  - `asset_id` `string` — The asset related to the activity — example: `12345`
  - `contract_id` `string` — The contract related to the activity — example: `12345`
  - `product_id` `string` — The product related to the activity — example: `12345`
  - `solution_id` `string` — The solution related to the activity — example: `12345`
  - `custom_object_id` `string` — The custom object related to the activity — example: `12345`
  - `type` `string` **required** — The type of the activity — enum: `call`, `meeting`, `email`, `note`, `task`, `deadline`, `send-letter`, `send-quote`, `other` — example: `meeting`
  - `title` `string` — The title of the activity — example: `Meeting`
  - `description` `string` — A description of the activity — example: `More info about the meeting`
  - `note` `string` — An internal note about the activity — example: `An internal note about the meeting`
  - `location` `string` — The location of the activity — example: `Space`
  - `location_address` `object`
    - `id` `string` — Unique identifier for the address. — example: `123`
    - `type` `string` — The type of address. — enum: `primary`, `secondary`, `home`, `office`, `shipping`, `billing`, `work`, `other` — example: `primary`
    - `string` `string` — The address string. Some APIs don't provide structured address data. — example: `25 Spring Street, Blackburn, VIC 3130`
    - `name` `string` — The name of the address. — example: `HQ US`
    - `line1` `string` — Line 1 of the address e.g. number, street, suite, apt #, etc. — example: `Main street`
    - `line2` `string` — Line 2 of the address — example: `apt #`
    - `line3` `string` — Line 3 of the address — example: `Suite #`
    - `line4` `string` — Line 4 of the address — example: `delivery instructions`
    - `line5` `string` — Line 5 of the address — example: `Attention: Finance Dept`
    - `street_number` `string` — Street number — example: `25`
    - `city` `string` — Name of city. — example: `San Francisco`
    - `state` `string` — Name of state — example: `CA`
    - `postal_code` `string` — Zip code or equivalent. — example: `94104`
    - `country` `string` — country code according to ISO 3166-1 alpha-2. — example: `US`
    - `latitude` `string` — Latitude of the address — example: `40.759211`
    - `longitude` `string` — Longitude of the address — example: `-73.984638`
    - `county` `string` — Address field that holds a sublocality, such as a county — example: `Santa Clara`
    - `contact_name` `string` — Name of the contact person at the address — example: `Elon Musk`
    - `salutation` `string` — Salutation of the contact person at the address — example: `Mr`
    - `phone_number` `string` — Phone number of the address — example: `111-111-1111`
    - `fax` `string` — Fax number of the address — example: `122-111-1111`
    - `email` `string` — Email address of the address — example: `elon@musk.com`
    - `website` `string` — Website of the address — example: `https://elonmusk.com`
    - `notes` `string` — Additional notes — example: `Address notes or delivery instructions.`
    - `row_version` `string` — A binary value used to detect updates to a object and prevent data conflicts. It is incremented each time an update is made to the object. — example: `1-12345`
  - `all_day_event` `boolean` — Whether the Activity is an all day event or not — example: `false`
  - `private` `boolean` — Whether the Activity is private or not — example: `true`
  - `group_event` `boolean` — Whether the Activity is a group event or not — example: `true`
  - `event_sub_type` `string` — The sub type of the group event — example: `debrief`
  - `group_event_type` `string` — The type of the group event — example: `Proposed`
  - `child` `boolean` — Whether the activity is a child of another activity or not — example: `false`
  - `archived` `boolean` — Whether the activity is archived or not — example: `false`
  - `deleted` `boolean` — Whether the activity is deleted or not — example: `false`
  - `show_as` `string` — enum: `free`, `busy` — example: `busy`
  - `done` `boolean` — Whether the Activity is done or not — example: `false`
  - `start_datetime` `string` — The start date and time of the activity — example: `2021-05-01T12:00:00.000Z`
  - `end_datetime` `string` — The end date and time of the activity — example: `2021-05-01T12:30:00.000Z`
  - `duration_minutes` `integer` — The duration of the activity in minutes — example: `30`
  - `activity_date` `string` — The date of the activity — example: `2021-05-01`
  - `end_date` `string` — The end date of the activity — example: `2021-05-01`
  - `recurrent` `boolean` — Whether the activity is recurrent or not — example: `false`
  - `reminder_datetime` `string` — The date and time of the reminder — example: `2021-05-01T17:00:00.000Z`
  - `reminder_set` `boolean` — Whether the reminder is set or not — example: `false`
  - `video_conference_url` `string` — The URL of the video conference — example: `https://meet.example.com/j/88120759396`
  - `video_conference_id` `string` — The ID of the video conference — example: `zoom:88120759396`
  - `custom_fields` `array of object` — Custom fields of the activity
    - `id` `string` — Unique identifier for the custom field. — example: `2389328923893298`
    - `name` `string` — Name of the custom field. — example: `employee_level`
    - `description` `string` — More information about the custom field — example: `Employee Level`
    - `value` `string | number | boolean | object | array of string | number | boolean | object`
      - One of:
        - Option 1: string
        - Option 2: number
        - Option 3: boolean
        - Option 4: object

        - Option 5: array of string | number | boolean | object
  - `attendees` `array of object`
    - `id` `string` — Unique identifier for the attendee — example: `12345`
    - `name` `string` — Full name of the attendee — example: `Elon Musk`
    - `first_name` `string` — First name of the attendee — example: `Elon`
    - `middle_name` `string` — Middle name of the attendee — example: `D.`
    - `last_name` `string` — Last name of the attendee — example: `Musk`
    - `prefix` `string` — Prefix of the attendee — example: `Mr.`
    - `suffix` `string` — Suffix of the attendee — example: `PhD`
    - `email_address` `string` — Email address of the attendee — example: `elon@musk.com`
    - `is_organizer` `boolean` — Whether the attendee is the organizer of the activity — example: `true`
    - `status` `string` — Status of the attendee — enum: `accepted`, `tentative`, `declined` — example: `OK`
    - `user_id` `string` — The identifier for a related user — example: `12345`
    - `contact_id` `string` — The identifier for a related contact — example: `12345`
    - `updated_at` `string` — The last time the attendee was updated (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
    - `created_at` `string` — The time the attendee was created (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
  - `custom_mappings` `object` — When custom mappings are configured on the resource, the result is included here.
  - `updated_by` `string` — The user who last updated the activity — example: `12345`
  - `created_by` `string` — The user who created the activity — example: `12345`
  - `updated_at` `string` — The date and time when the activity was last updated — example: `2020-09-30T07:43:32.000Z`
  - `created_at` `string` — The date and time when the activity was created — example: `2020-09-30T07:43:32.000Z`
  - `pass_through` `array of object` — The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources.
    - `service_id` `string` **required** — Identifier for the service to which this pass_through should be applied.
    - `operation_id` `string` — Optional identifier for a workflow operation to which this pass_through should be applied. This is useful for Unify calls that are making more than one downstream request.
    - `extend_object` `object` — Simple object allowing any properties for direct extension.
    - `extend_paths` `array of object` — Array of objects for structured data modifications via paths.
      - `path` `string` **required** — JSONPath string specifying where to apply the value. — example: `$.nested.property`
      - `value` `any` **required** — The value to set at the specified path, can be any type.
- `_raw` `object` — Raw response from the integration when raw=true query param is provided
- `meta` `object` — Response metadata
  - `items_on_page` `integer` — Number of items returned in the data property of the response — example: `50`
  - `cursors` `object` — Cursors to navigate to previous or next pages through the API
    - `previous` `string` — Cursor to navigate to the previous page of results through the API — example: `em9oby1jcm06OnBhZ2U6OjE=`
    - `current` `string` — Cursor to navigate to the current page of results through the API — example: `em9oby1jcm06OnBhZ2U6OjI=`
    - `next` `string` — Cursor to navigate to the next page of results through the API — example: `em9oby1jcm06OnBhZ2U6OjM=`
- `links` `object` — Links to navigate to previous or next pages through the API
  - `previous` `string` — Link to navigate to the previous page through the API — example: `https://unify.apideck.com/crm/companies?cursor=em9oby1jcm06OnBhZ2U6OjE%3D`
  - `current` `string` — Link to navigate to the current page through the API — example: `https://unify.apideck.com/crm/companies`
  - `next` `string` — Link to navigate to the previous page through the API — example: `https://unify.apideck.com/crm/companies?cursor=em9oby1jcm06OnBhZ2U6OjM`

#### 400 — Bad Request

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 401 — Unauthorized

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 402 — Payment Required

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 404 — The specified resource was not found

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 422 — Unprocessable

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### default — Unexpected error

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

---

# Create activity

> **CRM API** · `POST /crm/activities`
> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities/operation/activitiesAdd

Create activity

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `raw` | query | `boolean` | No | Include raw response. Mostly used for debugging purposes |
| `x-apideck-consumer-id` | header | `string` | Yes | ID of the consumer which you want to get or push data from |
| `x-apideck-app-id` | header | `string` | Yes | The ID of your Unify application |
| `x-apideck-service-id` | header | `string` | No | Provide the service id you want to call (e.g., pipedrive). Only needed when a consumer has activated multiple integrations for a Unified API. |

### Request Body

_Required._

- `id` `string` — The unique identifier of the activity — example: `12345`
- `downstream_id` `string` — The third-party API ID of original entity — example: `12345`
- `activity_datetime` `string` — The date and time of the activity — example: `2021-05-01T12:00:00.000Z`
- `duration_seconds` `integer` — The duration of the activity in seconds — example: `1800`
- `user_id` `string` — The user related to the activity — example: `12345`
- `account_id` `string` — The account related to the activity — example: `12345`
- `contact_id` `string` — The contact related to the activity — example: `12345`
- `company_id` `string` — The company related to the activity — example: `12345`
- `opportunity_id` `string` — The opportunity related to the activity — example: `12345`
- `lead_id` `string` — The lead related to the activity — example: `12345`
- `owner_id` `string` — The owner of the activity — example: `12345`
- `campaign_id` `string` — The campaign related to the activity — example: `12345`
- `case_id` `string` — The case related to the activity — example: `12345`
- `asset_id` `string` — The asset related to the activity — example: `12345`
- `contract_id` `string` — The contract related to the activity — example: `12345`
- `product_id` `string` — The product related to the activity — example: `12345`
- `solution_id` `string` — The solution related to the activity — example: `12345`
- `custom_object_id` `string` — The custom object related to the activity — example: `12345`
- `type` `string` **required** — The type of the activity — enum: `call`, `meeting`, `email`, `note`, `task`, `deadline`, `send-letter`, `send-quote`, `other` — example: `meeting`
- `title` `string` — The title of the activity — example: `Meeting`
- `description` `string` — A description of the activity — example: `More info about the meeting`
- `note` `string` — An internal note about the activity — example: `An internal note about the meeting`
- `location` `string` — The location of the activity — example: `Space`
- `location_address` `object`
  - `id` `string` — Unique identifier for the address. — example: `123`
  - `type` `string` — The type of address. — enum: `primary`, `secondary`, `home`, `office`, `shipping`, `billing`, `work`, `other` — example: `primary`
  - `string` `string` — The address string. Some APIs don't provide structured address data. — example: `25 Spring Street, Blackburn, VIC 3130`
  - `name` `string` — The name of the address. — example: `HQ US`
  - `line1` `string` — Line 1 of the address e.g. number, street, suite, apt #, etc. — example: `Main street`
  - `line2` `string` — Line 2 of the address — example: `apt #`
  - `line3` `string` — Line 3 of the address — example: `Suite #`
  - `line4` `string` — Line 4 of the address — example: `delivery instructions`
  - `line5` `string` — Line 5 of the address — example: `Attention: Finance Dept`
  - `street_number` `string` — Street number — example: `25`
  - `city` `string` — Name of city. — example: `San Francisco`
  - `state` `string` — Name of state — example: `CA`
  - `postal_code` `string` — Zip code or equivalent. — example: `94104`
  - `country` `string` — country code according to ISO 3166-1 alpha-2. — example: `US`
  - `latitude` `string` — Latitude of the address — example: `40.759211`
  - `longitude` `string` — Longitude of the address — example: `-73.984638`
  - `county` `string` — Address field that holds a sublocality, such as a county — example: `Santa Clara`
  - `contact_name` `string` — Name of the contact person at the address — example: `Elon Musk`
  - `salutation` `string` — Salutation of the contact person at the address — example: `Mr`
  - `phone_number` `string` — Phone number of the address — example: `111-111-1111`
  - `fax` `string` — Fax number of the address — example: `122-111-1111`
  - `email` `string` — Email address of the address — example: `elon@musk.com`
  - `website` `string` — Website of the address — example: `https://elonmusk.com`
  - `notes` `string` — Additional notes — example: `Address notes or delivery instructions.`
  - `row_version` `string` — A binary value used to detect updates to a object and prevent data conflicts. It is incremented each time an update is made to the object. — example: `1-12345`
- `all_day_event` `boolean` — Whether the Activity is an all day event or not — example: `false`
- `private` `boolean` — Whether the Activity is private or not — example: `true`
- `group_event` `boolean` — Whether the Activity is a group event or not — example: `true`
- `event_sub_type` `string` — The sub type of the group event — example: `debrief`
- `group_event_type` `string` — The type of the group event — example: `Proposed`
- `child` `boolean` — Whether the activity is a child of another activity or not — example: `false`
- `archived` `boolean` — Whether the activity is archived or not — example: `false`
- `deleted` `boolean` — Whether the activity is deleted or not — example: `false`
- `show_as` `string` — enum: `free`, `busy` — example: `busy`
- `done` `boolean` — Whether the Activity is done or not — example: `false`
- `start_datetime` `string` — The start date and time of the activity — example: `2021-05-01T12:00:00.000Z`
- `end_datetime` `string` — The end date and time of the activity — example: `2021-05-01T12:30:00.000Z`
- `duration_minutes` `integer` — The duration of the activity in minutes — example: `30`
- `activity_date` `string` — The date of the activity — example: `2021-05-01`
- `end_date` `string` — The end date of the activity — example: `2021-05-01`
- `recurrent` `boolean` — Whether the activity is recurrent or not — example: `false`
- `reminder_datetime` `string` — The date and time of the reminder — example: `2021-05-01T17:00:00.000Z`
- `reminder_set` `boolean` — Whether the reminder is set or not — example: `false`
- `video_conference_url` `string` — The URL of the video conference — example: `https://meet.example.com/j/88120759396`
- `video_conference_id` `string` — The ID of the video conference — example: `zoom:88120759396`
- `custom_fields` `array of object` — Custom fields of the activity
  - `id` `string` — Unique identifier for the custom field. — example: `2389328923893298`
  - `name` `string` — Name of the custom field. — example: `employee_level`
  - `description` `string` — More information about the custom field — example: `Employee Level`
  - `value` `string | number | boolean | object | array of string | number | boolean | object`
    - One of:
      - Option 1: string
      - Option 2: number
      - Option 3: boolean
      - Option 4: object

      - Option 5: array of string | number | boolean | object
- `attendees` `array of object`
  - `id` `string` — Unique identifier for the attendee — example: `12345`
  - `name` `string` — Full name of the attendee — example: `Elon Musk`
  - `first_name` `string` — First name of the attendee — example: `Elon`
  - `middle_name` `string` — Middle name of the attendee — example: `D.`
  - `last_name` `string` — Last name of the attendee — example: `Musk`
  - `prefix` `string` — Prefix of the attendee — example: `Mr.`
  - `suffix` `string` — Suffix of the attendee — example: `PhD`
  - `email_address` `string` — Email address of the attendee — example: `elon@musk.com`
  - `is_organizer` `boolean` — Whether the attendee is the organizer of the activity — example: `true`
  - `status` `string` — Status of the attendee — enum: `accepted`, `tentative`, `declined` — example: `accepted`
  - `user_id` `string` — The identifier for a related user — example: `12345`
  - `contact_id` `string` — The identifier for a related contact — example: `12345`
  - `updated_at` `string` — The last time the attendee was updated (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
  - `created_at` `string` — The time the attendee was created (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
- `custom_mappings` `object` — When custom mappings are configured on the resource, the result is included here.
- `updated_by` `string` — The user who last updated the activity — example: `12345`
- `created_by` `string` — The user who created the activity — example: `12345`
- `updated_at` `string` — The date and time when the activity was last updated — example: `2020-09-30T07:43:32.000Z`
- `created_at` `string` — The date and time when the activity was created — example: `2020-09-30T07:43:32.000Z`
- `pass_through` `array of object` — The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources.
  - `service_id` `string` **required** — Identifier for the service to which this pass_through should be applied.
  - `operation_id` `string` — Optional identifier for a workflow operation to which this pass_through should be applied. This is useful for Unify calls that are making more than one downstream request.
  - `extend_object` `object` — Simple object allowing any properties for direct extension.
  - `extend_paths` `array of object` — Array of objects for structured data modifications via paths.
    - `path` `string` **required** — JSONPath string specifying where to apply the value. — example: `$.nested.property`
    - `value` `any` **required** — The value to set at the specified path, can be any type.

### Responses

#### 201 — Activity created

- `status_code` `integer` **required** — HTTP Response Status Code — example: `201`
- `status` `string` **required** — HTTP Response Status — example: `Created`
- `service` `string` **required** — Apideck ID of service provider — example: `zoho-crm`
- `resource` `string` **required** — Unified API resource name — example: `activities`
- `operation` `string` **required** — Operation performed — example: `add`
- `data` `object` **required** — A object containing a unique identifier for the resource that was created, updated, or deleted.
  - `id` `string` **required** — The unique identifier of the resource — example: `12345`
- `_raw` `object` — Raw response from the integration when raw=true query param is provided

#### 400 — Bad Request

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 401 — Unauthorized

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 402 — Payment Required

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 404 — The specified resource was not found

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 422 — Unprocessable

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### default — Unexpected error

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

---

# Get activity

> **CRM API** · `GET /crm/activities/{id}`
> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities/operation/activitiesOne

Get activity

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `id` | path | `string` | Yes | ID of the record you are acting upon. |
| `x-apideck-consumer-id` | header | `string` | Yes | ID of the consumer which you want to get or push data from |
| `x-apideck-app-id` | header | `string` | Yes | The ID of your Unify application |
| `x-apideck-service-id` | header | `string` | No | Provide the service id you want to call (e.g., pipedrive). Only needed when a consumer has activated multiple integrations for a Unified API. |
| `raw` | query | `boolean` | No | Include raw response. Mostly used for debugging purposes |
| `fields` | query | `string` | No | The 'fields' parameter allows API users to specify the fields they want to include in the API response. If this parameter is not present, the API will return all available fields. If this parameter is present, only the fields specified in the comma-separated string will be included in the response. Nested properties can also be requested by using a dot notation. <br /><br />Example: `fields=name,email,addresses.city`<br /><br />In the example above, the response will only include the fields "name", "email" and "addresses.city". If any other fields are available, they will be excluded. |

### Responses

#### 200 — Activity

- `status_code` `integer` **required** — HTTP Response Status Code — example: `200`
- `status` `string` **required** — HTTP Response Status — example: `OK`
- `service` `string` **required** — Apideck ID of service provider — example: `zoho-crm`
- `resource` `string` **required** — Unified API resource name — example: `activities`
- `operation` `string` **required** — Operation performed — example: `one`
- `data` `object` **required**
  - `id` `string` — The unique identifier of the activity — example: `12345`
  - `downstream_id` `string` — The third-party API ID of original entity — example: `12345`
  - `activity_datetime` `string` — The date and time of the activity — example: `2021-05-01T12:00:00.000Z`
  - `duration_seconds` `integer` — The duration of the activity in seconds — example: `1800`
  - `user_id` `string` — The user related to the activity — example: `12345`
  - `account_id` `string` — The account related to the activity — example: `12345`
  - `contact_id` `string` — The contact related to the activity — example: `12345`
  - `company_id` `string` — The company related to the activity — example: `12345`
  - `opportunity_id` `string` — The opportunity related to the activity — example: `12345`
  - `lead_id` `string` — The lead related to the activity — example: `12345`
  - `owner_id` `string` — The owner of the activity — example: `12345`
  - `campaign_id` `string` — The campaign related to the activity — example: `12345`
  - `case_id` `string` — The case related to the activity — example: `12345`
  - `asset_id` `string` — The asset related to the activity — example: `12345`
  - `contract_id` `string` — The contract related to the activity — example: `12345`
  - `product_id` `string` — The product related to the activity — example: `12345`
  - `solution_id` `string` — The solution related to the activity — example: `12345`
  - `custom_object_id` `string` — The custom object related to the activity — example: `12345`
  - `type` `string` **required** — The type of the activity — enum: `call`, `meeting`, `email`, `note`, `task`, `deadline`, `send-letter`, `send-quote`, `other` — example: `meeting`
  - `title` `string` — The title of the activity — example: `Meeting`
  - `description` `string` — A description of the activity — example: `More info about the meeting`
  - `note` `string` — An internal note about the activity — example: `An internal note about the meeting`
  - `location` `string` — The location of the activity — example: `Space`
  - `location_address` `object`
    - `id` `string` — Unique identifier for the address. — example: `123`
    - `type` `string` — The type of address. — enum: `primary`, `secondary`, `home`, `office`, `shipping`, `billing`, `work`, `other` — example: `primary`
    - `string` `string` — The address string. Some APIs don't provide structured address data. — example: `25 Spring Street, Blackburn, VIC 3130`
    - `name` `string` — The name of the address. — example: `HQ US`
    - `line1` `string` — Line 1 of the address e.g. number, street, suite, apt #, etc. — example: `Main street`
    - `line2` `string` — Line 2 of the address — example: `apt #`
    - `line3` `string` — Line 3 of the address — example: `Suite #`
    - `line4` `string` — Line 4 of the address — example: `delivery instructions`
    - `line5` `string` — Line 5 of the address — example: `Attention: Finance Dept`
    - `street_number` `string` — Street number — example: `25`
    - `city` `string` — Name of city. — example: `San Francisco`
    - `state` `string` — Name of state — example: `CA`
    - `postal_code` `string` — Zip code or equivalent. — example: `94104`
    - `country` `string` — country code according to ISO 3166-1 alpha-2. — example: `US`
    - `latitude` `string` — Latitude of the address — example: `40.759211`
    - `longitude` `string` — Longitude of the address — example: `-73.984638`
    - `county` `string` — Address field that holds a sublocality, such as a county — example: `Santa Clara`
    - `contact_name` `string` — Name of the contact person at the address — example: `Elon Musk`
    - `salutation` `string` — Salutation of the contact person at the address — example: `Mr`
    - `phone_number` `string` — Phone number of the address — example: `111-111-1111`
    - `fax` `string` — Fax number of the address — example: `122-111-1111`
    - `email` `string` — Email address of the address — example: `elon@musk.com`
    - `website` `string` — Website of the address — example: `https://elonmusk.com`
    - `notes` `string` — Additional notes — example: `Address notes or delivery instructions.`
    - `row_version` `string` — A binary value used to detect updates to a object and prevent data conflicts. It is incremented each time an update is made to the object. — example: `1-12345`
  - `all_day_event` `boolean` — Whether the Activity is an all day event or not — example: `false`
  - `private` `boolean` — Whether the Activity is private or not — example: `true`
  - `group_event` `boolean` — Whether the Activity is a group event or not — example: `true`
  - `event_sub_type` `string` — The sub type of the group event — example: `debrief`
  - `group_event_type` `string` — The type of the group event — example: `Proposed`
  - `child` `boolean` — Whether the activity is a child of another activity or not — example: `false`
  - `archived` `boolean` — Whether the activity is archived or not — example: `false`
  - `deleted` `boolean` — Whether the activity is deleted or not — example: `false`
  - `show_as` `string` — enum: `free`, `busy` — example: `busy`
  - `done` `boolean` — Whether the Activity is done or not — example: `false`
  - `start_datetime` `string` — The start date and time of the activity — example: `2021-05-01T12:00:00.000Z`
  - `end_datetime` `string` — The end date and time of the activity — example: `2021-05-01T12:30:00.000Z`
  - `duration_minutes` `integer` — The duration of the activity in minutes — example: `30`
  - `activity_date` `string` — The date of the activity — example: `2021-05-01`
  - `end_date` `string` — The end date of the activity — example: `2021-05-01`
  - `recurrent` `boolean` — Whether the activity is recurrent or not — example: `false`
  - `reminder_datetime` `string` — The date and time of the reminder — example: `2021-05-01T17:00:00.000Z`
  - `reminder_set` `boolean` — Whether the reminder is set or not — example: `false`
  - `video_conference_url` `string` — The URL of the video conference — example: `https://meet.example.com/j/88120759396`
  - `video_conference_id` `string` — The ID of the video conference — example: `zoom:88120759396`
  - `custom_fields` `array of object` — Custom fields of the activity
    - `id` `string` — Unique identifier for the custom field. — example: `2389328923893298`
    - `name` `string` — Name of the custom field. — example: `employee_level`
    - `description` `string` — More information about the custom field — example: `Employee Level`
    - `value` `string | number | boolean | object | array of string | number | boolean | object`
      - One of:
        - Option 1: string
        - Option 2: number
        - Option 3: boolean
        - Option 4: object

        - Option 5: array of string | number | boolean | object
  - `attendees` `array of object`
    - `id` `string` — Unique identifier for the attendee — example: `12345`
    - `name` `string` — Full name of the attendee — example: `Elon Musk`
    - `first_name` `string` — First name of the attendee — example: `Elon`
    - `middle_name` `string` — Middle name of the attendee — example: `D.`
    - `last_name` `string` — Last name of the attendee — example: `Musk`
    - `prefix` `string` — Prefix of the attendee — example: `Mr.`
    - `suffix` `string` — Suffix of the attendee — example: `PhD`
    - `email_address` `string` — Email address of the attendee — example: `elon@musk.com`
    - `is_organizer` `boolean` — Whether the attendee is the organizer of the activity — example: `true`
    - `status` `string` — Status of the attendee — enum: `accepted`, `tentative`, `declined` — example: `OK`
    - `user_id` `string` — The identifier for a related user — example: `12345`
    - `contact_id` `string` — The identifier for a related contact — example: `12345`
    - `updated_at` `string` — The last time the attendee was updated (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
    - `created_at` `string` — The time the attendee was created (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
  - `custom_mappings` `object` — When custom mappings are configured on the resource, the result is included here.
  - `updated_by` `string` — The user who last updated the activity — example: `12345`
  - `created_by` `string` — The user who created the activity — example: `12345`
  - `updated_at` `string` — The date and time when the activity was last updated — example: `2020-09-30T07:43:32.000Z`
  - `created_at` `string` — The date and time when the activity was created — example: `2020-09-30T07:43:32.000Z`
  - `pass_through` `array of object` — The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources.
    - `service_id` `string` **required** — Identifier for the service to which this pass_through should be applied.
    - `operation_id` `string` — Optional identifier for a workflow operation to which this pass_through should be applied. This is useful for Unify calls that are making more than one downstream request.
    - `extend_object` `object` — Simple object allowing any properties for direct extension.
    - `extend_paths` `array of object` — Array of objects for structured data modifications via paths.
      - `path` `string` **required** — JSONPath string specifying where to apply the value. — example: `$.nested.property`
      - `value` `any` **required** — The value to set at the specified path, can be any type.
- `_raw` `object` — Raw response from the integration when raw=true query param is provided

#### 400 — Bad Request

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 401 — Unauthorized

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 402 — Payment Required

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 404 — The specified resource was not found

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 422 — Unprocessable

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### default — Unexpected error

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

---

# Delete activity

> **CRM API** · `DELETE /crm/activities/{id}`
> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities/operation/activitiesDelete

Delete activity

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `id` | path | `string` | Yes | ID of the record you are acting upon. |
| `x-apideck-consumer-id` | header | `string` | Yes | ID of the consumer which you want to get or push data from |
| `x-apideck-app-id` | header | `string` | Yes | The ID of your Unify application |
| `x-apideck-service-id` | header | `string` | No | Provide the service id you want to call (e.g., pipedrive). Only needed when a consumer has activated multiple integrations for a Unified API. |
| `raw` | query | `boolean` | No | Include raw response. Mostly used for debugging purposes |

### Responses

#### 200 — Activity deleted

- `status_code` `integer` **required** — HTTP Response Status Code — example: `200`
- `status` `string` **required** — HTTP Response Status — example: `OK`
- `service` `string` **required** — Apideck ID of service provider — example: `zoho-crm`
- `resource` `string` **required** — Unified API resource name — example: `activities`
- `operation` `string` **required** — Operation performed — example: `delete`
- `data` `object` **required** — A object containing a unique identifier for the resource that was created, updated, or deleted.
  - `id` `string` **required** — The unique identifier of the resource — example: `12345`
- `_raw` `object` — Raw response from the integration when raw=true query param is provided

#### 400 — Bad Request

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 401 — Unauthorized

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 402 — Payment Required

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 404 — The specified resource was not found

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 422 — Unprocessable

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### default — Unexpected error

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

---

# Update activity

> **CRM API** · `PATCH /crm/activities/{id}`
> Canonical URL: https://developers.apideck.com/apis/crm/reference#tag/Activities/operation/activitiesUpdate

Update activity

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `id` | path | `string` | Yes | ID of the record you are acting upon. |
| `x-apideck-consumer-id` | header | `string` | Yes | ID of the consumer which you want to get or push data from |
| `x-apideck-app-id` | header | `string` | Yes | The ID of your Unify application |
| `x-apideck-service-id` | header | `string` | No | Provide the service id you want to call (e.g., pipedrive). Only needed when a consumer has activated multiple integrations for a Unified API. |
| `raw` | query | `boolean` | No | Include raw response. Mostly used for debugging purposes |

### Request Body

_Required._

- `id` `string` — The unique identifier of the activity — example: `12345`
- `downstream_id` `string` — The third-party API ID of original entity — example: `12345`
- `activity_datetime` `string` — The date and time of the activity — example: `2021-05-01T12:00:00.000Z`
- `duration_seconds` `integer` — The duration of the activity in seconds — example: `1800`
- `user_id` `string` — The user related to the activity — example: `12345`
- `account_id` `string` — The account related to the activity — example: `12345`
- `contact_id` `string` — The contact related to the activity — example: `12345`
- `company_id` `string` — The company related to the activity — example: `12345`
- `opportunity_id` `string` — The opportunity related to the activity — example: `12345`
- `lead_id` `string` — The lead related to the activity — example: `12345`
- `owner_id` `string` — The owner of the activity — example: `12345`
- `campaign_id` `string` — The campaign related to the activity — example: `12345`
- `case_id` `string` — The case related to the activity — example: `12345`
- `asset_id` `string` — The asset related to the activity — example: `12345`
- `contract_id` `string` — The contract related to the activity — example: `12345`
- `product_id` `string` — The product related to the activity — example: `12345`
- `solution_id` `string` — The solution related to the activity — example: `12345`
- `custom_object_id` `string` — The custom object related to the activity — example: `12345`
- `type` `string` **required** — The type of the activity — enum: `call`, `meeting`, `email`, `note`, `task`, `deadline`, `send-letter`, `send-quote`, `other` — example: `meeting`
- `title` `string` — The title of the activity — example: `Meeting`
- `description` `string` — A description of the activity — example: `More info about the meeting`
- `note` `string` — An internal note about the activity — example: `An internal note about the meeting`
- `location` `string` — The location of the activity — example: `Space`
- `location_address` `object`
  - `id` `string` — Unique identifier for the address. — example: `123`
  - `type` `string` — The type of address. — enum: `primary`, `secondary`, `home`, `office`, `shipping`, `billing`, `work`, `other` — example: `primary`
  - `string` `string` — The address string. Some APIs don't provide structured address data. — example: `25 Spring Street, Blackburn, VIC 3130`
  - `name` `string` — The name of the address. — example: `HQ US`
  - `line1` `string` — Line 1 of the address e.g. number, street, suite, apt #, etc. — example: `Main street`
  - `line2` `string` — Line 2 of the address — example: `apt #`
  - `line3` `string` — Line 3 of the address — example: `Suite #`
  - `line4` `string` — Line 4 of the address — example: `delivery instructions`
  - `line5` `string` — Line 5 of the address — example: `Attention: Finance Dept`
  - `street_number` `string` — Street number — example: `25`
  - `city` `string` — Name of city. — example: `San Francisco`
  - `state` `string` — Name of state — example: `CA`
  - `postal_code` `string` — Zip code or equivalent. — example: `94104`
  - `country` `string` — country code according to ISO 3166-1 alpha-2. — example: `US`
  - `latitude` `string` — Latitude of the address — example: `40.759211`
  - `longitude` `string` — Longitude of the address — example: `-73.984638`
  - `county` `string` — Address field that holds a sublocality, such as a county — example: `Santa Clara`
  - `contact_name` `string` — Name of the contact person at the address — example: `Elon Musk`
  - `salutation` `string` — Salutation of the contact person at the address — example: `Mr`
  - `phone_number` `string` — Phone number of the address — example: `111-111-1111`
  - `fax` `string` — Fax number of the address — example: `122-111-1111`
  - `email` `string` — Email address of the address — example: `elon@musk.com`
  - `website` `string` — Website of the address — example: `https://elonmusk.com`
  - `notes` `string` — Additional notes — example: `Address notes or delivery instructions.`
  - `row_version` `string` — A binary value used to detect updates to a object and prevent data conflicts. It is incremented each time an update is made to the object. — example: `1-12345`
- `all_day_event` `boolean` — Whether the Activity is an all day event or not — example: `false`
- `private` `boolean` — Whether the Activity is private or not — example: `true`
- `group_event` `boolean` — Whether the Activity is a group event or not — example: `true`
- `event_sub_type` `string` — The sub type of the group event — example: `debrief`
- `group_event_type` `string` — The type of the group event — example: `Proposed`
- `child` `boolean` — Whether the activity is a child of another activity or not — example: `false`
- `archived` `boolean` — Whether the activity is archived or not — example: `false`
- `deleted` `boolean` — Whether the activity is deleted or not — example: `false`
- `show_as` `string` — enum: `free`, `busy` — example: `busy`
- `done` `boolean` — Whether the Activity is done or not — example: `false`
- `start_datetime` `string` — The start date and time of the activity — example: `2021-05-01T12:00:00.000Z`
- `end_datetime` `string` — The end date and time of the activity — example: `2021-05-01T12:30:00.000Z`
- `duration_minutes` `integer` — The duration of the activity in minutes — example: `30`
- `activity_date` `string` — The date of the activity — example: `2021-05-01`
- `end_date` `string` — The end date of the activity — example: `2021-05-01`
- `recurrent` `boolean` — Whether the activity is recurrent or not — example: `false`
- `reminder_datetime` `string` — The date and time of the reminder — example: `2021-05-01T17:00:00.000Z`
- `reminder_set` `boolean` — Whether the reminder is set or not — example: `false`
- `video_conference_url` `string` — The URL of the video conference — example: `https://meet.example.com/j/88120759396`
- `video_conference_id` `string` — The ID of the video conference — example: `zoom:88120759396`
- `custom_fields` `array of object` — Custom fields of the activity
  - `id` `string` — Unique identifier for the custom field. — example: `2389328923893298`
  - `name` `string` — Name of the custom field. — example: `employee_level`
  - `description` `string` — More information about the custom field — example: `Employee Level`
  - `value` `string | number | boolean | object | array of string | number | boolean | object`
    - One of:
      - Option 1: string
      - Option 2: number
      - Option 3: boolean
      - Option 4: object

      - Option 5: array of string | number | boolean | object
- `attendees` `array of object`
  - `id` `string` — Unique identifier for the attendee — example: `12345`
  - `name` `string` — Full name of the attendee — example: `Elon Musk`
  - `first_name` `string` — First name of the attendee — example: `Elon`
  - `middle_name` `string` — Middle name of the attendee — example: `D.`
  - `last_name` `string` — Last name of the attendee — example: `Musk`
  - `prefix` `string` — Prefix of the attendee — example: `Mr.`
  - `suffix` `string` — Suffix of the attendee — example: `PhD`
  - `email_address` `string` — Email address of the attendee — example: `elon@musk.com`
  - `is_organizer` `boolean` — Whether the attendee is the organizer of the activity — example: `true`
  - `status` `string` — Status of the attendee — enum: `accepted`, `tentative`, `declined` — example: `accepted`
  - `user_id` `string` — The identifier for a related user — example: `12345`
  - `contact_id` `string` — The identifier for a related contact — example: `12345`
  - `updated_at` `string` — The last time the attendee was updated (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
  - `created_at` `string` — The time the attendee was created (ISO 8601) — format: `date-time` — example: `2017-08-12T20:43:21.291Z`
- `custom_mappings` `object` — When custom mappings are configured on the resource, the result is included here.
- `updated_by` `string` — The user who last updated the activity — example: `12345`
- `created_by` `string` — The user who created the activity — example: `12345`
- `updated_at` `string` — The date and time when the activity was last updated — example: `2020-09-30T07:43:32.000Z`
- `created_at` `string` — The date and time when the activity was created — example: `2020-09-30T07:43:32.000Z`
- `pass_through` `array of object` — The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources.
  - `service_id` `string` **required** — Identifier for the service to which this pass_through should be applied.
  - `operation_id` `string` — Optional identifier for a workflow operation to which this pass_through should be applied. This is useful for Unify calls that are making more than one downstream request.
  - `extend_object` `object` — Simple object allowing any properties for direct extension.
  - `extend_paths` `array of object` — Array of objects for structured data modifications via paths.
    - `path` `string` **required** — JSONPath string specifying where to apply the value. — example: `$.nested.property`
    - `value` `any` **required** — The value to set at the specified path, can be any type.

### Responses

#### 200 — Activity updated

- `status_code` `integer` **required** — HTTP Response Status Code — example: `200`
- `status` `string` **required** — HTTP Response Status — example: `OK`
- `service` `string` **required** — Apideck ID of service provider — example: `zoho-crm`
- `resource` `string` **required** — Unified API resource name — example: `activities`
- `operation` `string` **required** — Operation performed — example: `update`
- `data` `object` **required** — A object containing a unique identifier for the resource that was created, updated, or deleted.
  - `id` `string` **required** — The unique identifier of the resource — example: `12345`
- `_raw` `object` — Raw response from the integration when raw=true query param is provided

#### 400 — Bad Request

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 401 — Unauthorized

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 402 — Payment Required

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 404 — The specified resource was not found

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### 422 — Unprocessable

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

#### default — Unexpected error

> Standard error response — see [Error Responses](https://developers.apideck.com/errors)

---
